HowTo: Debug a Shell Script Under Linux or UNIX

by on January 29, 2007 · 20 comments· LAST UPDATED February 3, 2012

in , ,

Raju asks:

How can I Debug a shell scripts?

This is most common question asked by new admins or UNIX user.

Shell scripting debugging can be boring job (read as not easy). There are various ways to debug a shell script.

-x option to debug a shell script

Run a shell script with -x option.
$ bash -x script-name
$ bash -x domains.sh

Use of set builtin command

Bash shell offers debugging options which can be turn on or off using set command.

  • set -x : Display commands and their arguments as they are executed.
  • set -v : Display shell input lines as they are read.

You can use above two command in shell script itself:

#!/bin/bash
clear
# turn on debug mode
set -x
for f in *
do
   file $f
done
# turn OFF debug mode
set +x
ls
# more commands 
 

You can replace the standard Shebang line:
#!/bin/bash
with the following (for debugging) code:
#!/bin/bash -xv

Use of intelligent DEBUG function

First, add a special variable called _DEBUG. Set _DEBUG to 'on' when you need to debug a script:
_DEBUG="on"

Put the following function at the beginning of the script:

function DEBUG()
{
 [ "$_DEBUG" == "on" ] &&  $@
}

Now wherever you need debugging simply use the DEBUG function as follows:
DEBUG echo "File is $filename"
OR
DEBUG set -x
Cmd1
Cmd2
DEBUG set +x

When done with debugging (and before moving your script to production) set _DEBUG to 'off'. No need to delete debug lines.
_DEBUG="off" # set to anything but not to 'on'

Sample script:

 
#!/bin/bash
_DEBUG="on"
function DEBUG()
{
 [ "$_DEBUG" == "on" ] &&  $@
}
 
DEBUG echo 'Reading files'
for i in *
do
  grep 'something' $i > /dev/null
  [ $? -eq 0 ] && echo "Found in $i file"
done
DEBUG set -x
a=2
b=3
c=$(( $a + $b ))
DEBUG set +x
echo "$a + $b = $c"
 

Save and close the file. Run the script as follows:
$ ./script.sh
Output:

Reading files
Found in xyz.txt file
+ a=2
+ b=3
+ c=5
+ DEBUG set +x
+ '[' on == on ']'
+ set +x
2 + 3 = 5

Now set DEBUG to off (you need to edit the file):
_DEBUG="off"
Run script:
$ ./script.sh
Output:

Found in xyz.txt file
2 + 3 = 5

Above is a simple but quite effective technique. You can also try to use DEBUG as an alias instead of function.

Debugging Common Bash Shell Scripting Errors

Bash or sh or ksh gives various error messages on screen and in many case the error message may not provide detailed information.

End of file unexpected Error

If you are getting an End of file unexpected error message, open your script file and and make sure it has both opening and closing quotes. In this example, the echo statement has an opening quote but no closing quote:

#!/bin/bash
...
....
echo 'Error: File not found
                                        ^^^^^^^
                                        missing quote

Also make sure you check for missing parentheses and braces ({}):

#!/bin/bash
.....
[ ! -d $DIRNAME ] && { echo "Error: Chroot dir not found"; exit 1;
                                                                    ^^^^^^^^^^^^^
                                                                    missing brace }
...
 

Missing Keywords Such As fi, esac, ;;, etc.

If you missed ending keyword such as fi or ;; you will get an error such as as "xxx unexpected". So make sure all nested if and case statements ends with proper keywords. See bash man page for syntax requirements. In this example, fi is missing:

#!/bin/bash
echo "Starting..."
....
if [ $1 -eq 10 ]
then
   if [ $2 -eq 100 ]
   then
      echo "Do something"
fi
 
for f in $files
do
  echo $f
done
 
# note fi is missing
 

Tip#1: Send Debug Message To stderr

Standard error is the default error output device, which is used to write all system error messages. So it is a good idea to send messages to the default error device:

# Write error to stdout
echo "Error: $1 file not found"
#
# Write error to stderr (note 1>&2 at the end of echo command)
#
echo "Error: $1 file not found" 1>&2

Tip#2: Turn On Syntax Highlighting

Most modern text editors allows you to set syntax highlighting option. This is useful to detect syntax and prevent common errors such as opening or closing quote. You can see bash script in different colors. This feature eases writing in a shell script structures and syntax errors are visually distinct. Highlighting does not affect the meaning of the text itself; it's made only for you. In this example, vim syntax highlighting is used for my bash script:

Fig.01: Bash shell script syntax highlighting using vim text editor

Fig.01: Bash shell script syntax highlighting using vim text editor

See also:

TwitterFacebookGoogle+PDF versionFound an error/typo on this page? Help us!

{ 20 comments… read them below or add one }

1 _ranger_ January 31, 2007 at 3:30 pm

For running under “set -x” or “set +x”, why not just run it as:

bash -x ./script.sh

Also, instead of having _DEBUG in your script, just export it from your shell:

$ export _DEBUG=on

Now, you have to make absolutely no changes to enable or disable all debugging.

Reply

2 nixCraft February 1, 2007 at 10:00 pm

_ranger_,

Good idea however you may have to modify script little to check if _DEBUG is defined or not.

Appreciate your post.

Reply

3 sartan February 19, 2008 at 12:59 am

I liked this debug method and implemented it in a simple script I wrote :) It really does make for much cleaner code than what I have been doing before. Thanks mate

Reply

4 thievm May 8, 2008 at 11:33 am

thanks,it is good idea

Reply

5 mosjin May 20, 2008 at 7:37 am

It’s a good idea. Thanks!

Reply

6 yura December 27, 2008 at 8:52 pm
7 dekkard January 11, 2010 at 6:37 am

very nice, thanx

Reply

8 psc January 27, 2010 at 10:01 pm

[ “$_DEBUG” == “on” ] && $@ || :

Why are you using last || operator?

Reply

9 nixCraft January 28, 2010 at 4:36 am

Yes, it is not required.

Reply

10 Philippe Petrinko May 19, 2010 at 5:06 pm

Hi Vivek,
if this is not required, would you consider cleaning code – mainly because that may confuse novice programmers and may induce bugs … Thanks in advance! Nice topic, one more!

Reply

11 nixCraft May 20, 2010 at 8:17 pm

Philippe,

Thanks for your feedback. The post has been updated.

Reply

12 geek May 16, 2013 at 6:07 pm

|| : will make sure the return code is true, which allows the script to run under -e mode without it breaking due to problems with debug commands. Using -e when debugging may be very helpful.

On a related note: You can set variables on a by-call basis like this:
_DEBUG=”on” command. No export required, thus no later unexport required. All nice and local.

Reply

13 Harvey June 13, 2013 at 1:27 am

The || should remain so it will work with “set -e”. To make it clearer, perhaps:

[ “$_DEBUG” == “on” ] && $@ || return 0

Reply

14 SS Senthil Kumar March 22, 2011 at 5:03 pm

I am going to move from HP-Unix to Redhat Linux server. I have many bash shell programs in HP-Unix. Will they need change when i move to Linux (RHEL)? Kindly advice.

Reply

15 achyut July 6, 2011 at 12:27 pm

Excellent Topic

Reply

16 igor January 16, 2013 at 1:03 pm

Very helpful. I have bookmarked this page, as it will help me port a Windows batch file into a Linux script.

Reply

17 sai ram September 10, 2013 at 12:15 pm

why are we using this instruction >> “$_DEBUG” == “on” ] && $@

Reply

18 Dave Lane October 21, 2013 at 3:37 am

Very useful – thank you!

You can change the function to handle multiline statements with the following:

function DEBUG {
    if [ "$_DEBUG" == "on" ] ; then
        $@
    else
        : $@
    fi
}

Reply

19 Dave Lane October 21, 2013 at 4:02 am

Or, better:-

function DEBUG {
    if [ "$_DEBUG" == "on" ] ; then
        "$@"
    else
        : "$@"
    fi
}

This handles statements like:-

DEBUG printf "%12d     %s\n" \
            123 "hello"

Reply

20 Laurent_L March 30, 2014 at 6:23 pm

Hello,

First, many thanks for this very good HowTo.

About the function DEBUG:
In the form proposed

function DEBUG()
{
 [ "$_DEBUG" == "on" ] &&  $@
}

it’s OK for an echo command, but if I try

a=1
DEBUG a=2

I obtain an error message.
So, I’m using this form :

function DEBUG()
{
 [ "$_DEBUG" == "on" ] && eval $@
}

which is OK for me.
More precisely, my debug function is

debug_cmd ()
{
    if [ ! -z "${DEBUG}" ]
    then
        msg_head=$(caller 0)
        echo "[ ${msg_head} ] $@" >&2
        read -p "Run it [N/y] ? "
        if [ "$REPLY" = "y" ] || [ "$REPLY" = "Y" ]
        then
            eval $@
        fi
    fi
}

This one allows me to view the command before choosing to run it or to ignore it.
It’s OK for a command like ‘a=2′, but fails with a command ‘echo “pouet (a=$a)”.
Not really a problem if we use debug_cmd only for commands like variable affectation, or function calls, not for simple echo commands.

Regards,

Laurent.

Reply

Leave a Comment

Tagged as: , , , , , , , , , , , , ,

Previous post:

Next post: